/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void OpenCB(), SaveCB();
static Widget toplevel, text;
static Atom xa_wm_delete;
static Atom xa_wm_save;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget panel, field, label, fname, open, save;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Sessionsave", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ե̾Ϥƥץ󤹤ΰ */
    ac = 0;
    field = XmCreateRowColumn(panel, "field", al, ac);
    XtManageChild(field);
    /* "ե̾: */
    ac = 0;
    label = XmCreateLabel(field, "label", al, ac);
    XtManageChild(label);
    /* ΰ */
    ac = 0;
    fname = XmCreateTextField(field, "fname", al, ac);
    XtManageChild(fname);
    /* [ץ] */
    ac = 0;
    open = XmCreatePushButton(field, "open", al, ac);
    XtAddCallback(open, XmNactivateCallback, OpenCB, fname);
    XtManageChild(open);
    /* [¸] */
    ac = 0;
    save = XmCreatePushButton(field, "save", al, ac);
    XtAddCallback(save, XmNactivateCallback, SaveCB, fname);
    XtManageChild(save);

    /* եƤɽΰ */
    ac = 0;
    text = XmCreateScrolledText(panel, "text", al, ac);
    XtManageChild(text);
    XtVaSetValues(XtParent(text), XmNtopWidget, field, NULL);

    /* "WM_DELETE_WINDOW" Υץȥ롦ХåϿ */
    xa_wm_delete = XmInternAtom(XtDisplay(toplevel), "WM_DELETE_WINDOW", False);
    XmAddWMProtocolCallback(toplevel, xa_wm_delete, SaveCB, fname);

    /* (1) "WM_SAVE_YOURSELF" Υץȥ롦ХåϿ */
    xa_wm_save = XmInternAtom(XtDisplay(toplevel), "WM_SAVE_YOURSELF", False);
    XmAddWMProtocolCallback(toplevel, xa_wm_save, SaveCB, fname);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* [ץ] ܥΥХå */
static void OpenCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget textf = (Widget)client_data;
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];

    /* Ϥ줿ե̾Ф */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* եƤƥȤɽ */
    if ((fp = fopen(filename, "r")) != NULL) {  /* ե򥪡ץ */
        XmTextSetString(text, "");  /* äƥȤƤõ */
        while (fgets(buff, BUFSIZ, fp) != NULL)
            XmTextInsert(text, XmTextGetLastPosition(text), buff); /* ɲ */
        fclose(fp);
    }

    XtFree(filename);
}

/* [¸] ܥΥХå */
/* ɥ˥塼 "Close" ܥ󤬲줿ȤƤӽФ */
/* (2) å󤬽λȤˤƤӽФ */
static void SaveCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmAnyCallbackStruct *cb = (XmAnyCallbackStruct *)call_data;
    Widget textf = (Widget)client_data;
    char *filename;
    char *string;
    FILE *fp;

    /* ȥåץ٥ʳ "Close" ܥ󤬲줿Ȥϲ⤷ʤ */
    if (cb->reason == XmCR_WM_PROTOCOLS &&  /* ɥޥ͡㤫餫 */
         cb->event->type == ClientMessage &&  /* 饤ȡå */
          cb->event->xclient.data.l[0] == xa_wm_delete &&  /* "Close"  */
           w != toplevel)  /* ȥåץ٥뤫 */
        return;

    /* Ϥ줿ե̾Ф */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* ƥȤƤФ */
    string = XmTextGetString(text);

    /* ƥȤƤե˽񤭽Ф */
    if ((fp = fopen(filename, "w")) != NULL) {  /* ե򥪡ץ */
        fputs(string, fp);
        fclose(fp);
    }

    XtFree(filename);
    XtFree(string);

    /* (3) "WM_SAVE_YOURSELF" Ƥå󤬽λ褦ȤƤ*/
    if (cb->reason == XmCR_WM_PROTOCOLS &&  /* å󡦥ޥ͡㤫餫 */
         cb->event->type == ClientMessage &&  /* 饤ȡå */
          cb->event->xclient.data.l[0] == xa_wm_save)  /* åλ */
        /* "WM_COMMAND" ץѥƥ򹹿ơå󡦥ޥ͡˹ */
        XChangeProperty(XtDisplay(toplevel), XtWindow(toplevel),
                        XA_WM_COMMAND, XA_STRING, 8, PropModeAppend, NULL, 0);
}
